## org.eclipse.jst.jsf.context.symbol
Interface ITypeDescriptor

All Known Subinterfaces:
  IBoundedJavaTypeDescriptor, IBoundedListTypeDescriptor, IBoundedMapTypeDescriptor, IBoundedTypeDescriptor, IJavaTypeDescriptor2, IListTypeDescriptor, IMapTypeDescriptor

    public interface ITypeDescriptor

A generic descriptor for symbol information

Provisional API - subject to change

Field Summary
`static java.lang.String` `copyright`

Method Summary
`ISymbol` `calculateSyntheticCall(java.lang.String methodName, EList methodArgs, java.lang.String symbolName)`
`IObjectSymbol` `getArrayElement()`
`EList` `getInterfaceTypeSignatures()` Returns the value of the 'Interface Type Signatures' attribute list.
`IJavaElement` `getJdtContext()` Returns the value of the 'Jdt Context' attribute
`EList` `getMethods()` Returns the value of the 'Methods' reference list.
`EList` `getProperties()` Returns the value of the 'Properties' reference list.
`EList` `getSuperTypeSignatures()` Returns the value of the 'Super Type Signatures' attribute list.
`EList` `getTypeParameterSignatures()` Returns the value of the 'Type Parameter Signatures' attribute list.
`java.lang.String` `getTypeSignature()` Returns the value of the 'Type Signature' attribute.
`java.lang.String` `getTypeSignatureDelegate()` Returns the value of the 'Type Signature Delegate' attribute
`boolean` `instanceOf(java.lang.String typeSignature)`
`boolean` `isArray()`
`boolean` `isEnumType()` Returns the value of the 'Enum Type' attribute
`IType` `resolveType(java.lang.String resolvedTypeSignature)`
`void` `setEnumType(boolean value)` Sets the value of the '`Enum Type`' attribute
`void` `setJdtContext(IJavaElement value)` Sets the value of the '`Jdt Context`' attribute
`void` `setTypeSignatureDelegate(java.lang.String value)` Sets the value of the '`Type Signature Delegate`' attribute

Field Detail

### copyright

    static final java.lang.String copyright

  See Also:
    Constant Field Values

Method Detail

### getProperties

    EList getProperties()

  Returns the value of the 'Properties' reference list. The list contents are of type `IPropertySymbol`.

  If the meaning of the 'Properties' reference list isn't clear, there really should be more of a description here...

  Returns:
    the value of the 'Properties' reference list.
  See Also:
    `SymbolPackage.getITypeDescriptor_Properties()`

### getTypeSignature

    java.lang.String getTypeSignature()

  Returns the value of the 'Type Signature' attribute. The default value is `""`.

  If the meaning of the 'Type Signature' attribute isn't clear, there really should be more of a description here...

  Returns:
    the value of the 'Type Signature' attribute.
  See Also:
    `SymbolPackage.getITypeDescriptor_TypeSignature()`

### getSuperTypeSignatures

    EList getSuperTypeSignatures()

  Returns the value of the 'Super Type Signatures' attribute list. The list contents are of type `String`.

  If the meaning of the 'Super Type Signatures' attribute list isn't clear, there really should be more of a description here...

  Returns:
    the value of the 'Super Type Signatures' attribute list.
  See Also:
    `SymbolPackage.getITypeDescriptor_SuperTypeSignatures()`

### getInterfaceTypeSignatures

    EList getInterfaceTypeSignatures()

  Returns the value of the 'Interface Type Signatures' attribute list. The list contents are of type `String`.

  If the meaning of the 'Interface Type Signatures' attribute list isn't clear, there really should be more of a description here...

  Returns:
    the value of the 'Interface Type Signatures' attribute list.
  See Also:
    `SymbolPackage.getITypeDescriptor_InterfaceTypeSignatures()`

### getTypeSignatureDelegate

    java.lang.String getTypeSignatureDelegate()

  Returns the value of the 'Type Signature Delegate' attribute.

  If the meaning of the 'Type Signature Delegate' attribute isn't clear, there really should be more of a description here...

  Returns:
    the value of the 'Type Signature Delegate' attribute.
  See Also:
    `setTypeSignatureDelegate(String)`, `SymbolPackage.getITypeDescriptor_TypeSignatureDelegate()`

### setTypeSignatureDelegate

    void setTypeSignatureDelegate(java.lang.String value)

  Sets the value of the '`Type Signature Delegate`' attribute.

  Parameters:
    `value` - the new value of the 'Type Signature Delegate' attribute.
  See Also:
    `getTypeSignatureDelegate()`

### getMethods

    EList getMethods()

  Returns the value of the 'Methods' reference list. The list contents are of type `IMethodSymbol`.

  If the meaning of the 'Methods' reference list isn't clear, there really should be more of a description here...

  Returns:
    the value of the 'Methods' reference list.
  See Also:
    `SymbolPackage.getITypeDescriptor_Methods()`

### getTypeParameterSignatures

    EList getTypeParameterSignatures()

  Returns the value of the 'Type Parameter Signatures' attribute list. The list contents are of type `String`.

  If the meaning of the 'Type Parameter Signatures' attribute list isn't clear, there really should be more of a description here...

  Returns:
    the value of the 'Type Parameter Signatures' attribute list.
  See Also:
    `SymbolPackage.getITypeDescriptor_TypeParameterSignatures()`

### getJdtContext

    IJavaElement getJdtContext()

  Returns the value of the 'Jdt Context' attribute.

  If the meaning of the 'Jdt Context' attribute isn't clear, there really should be more of a description here...

  Returns:
    the value of the 'Jdt Context' attribute.
  See Also:
    `setJdtContext(IJavaElement)`, `SymbolPackage.getITypeDescriptor_JdtContext()`

### setJdtContext

    void setJdtContext(IJavaElement value)

  Sets the value of the '`Jdt Context`' attribute.

  Parameters:
    `value` - the new value of the 'Jdt Context' attribute.
  See Also:
    `getJdtContext()`

### isEnumType

    boolean isEnumType()

  Returns the value of the 'Enum Type' attribute.

  If the meaning of the 'Enum Type' attribute isn't clear, there really should be more of a description here...

  Returns:
    the value of the 'Enum Type' attribute.
  See Also:
    `setEnumType(boolean)`, `SymbolPackage.getITypeDescriptor_EnumType()`

### setEnumType

    void setEnumType(boolean value)

  Sets the value of the '`Enum Type`' attribute.

  Parameters:
    `value` - the new value of the 'Enum Type' attribute.
  See Also:
    `isEnumType()`

### instanceOf

    boolean instanceOf(java.lang.String typeSignature)

  Parameters:
    `typeSignature` -
  Returns:
    true if the type descriptor's underlying type would resolve true == (type instanceof typeSignature)

### isArray

    boolean isArray()

  Returns:
    true iff this type is an array of something

### getArrayElement

    IObjectSymbol getArrayElement()

  Returns:
    a symbol representing an element of this array. May throw an exception or return null if isArray() == false

### resolveType

    IType resolveType(java.lang.String resolvedTypeSignature)

  Parameters:
    `resolvedTypeSignature` -
  Returns:
    the IType for resolvedTypeSignature or null if can't be resolved

### calculateSyntheticCall

    ISymbol calculateSyntheticCall(java.lang.String methodName,
                                   EList methodArgs,
                                   java.lang.String symbolName)

  Parameters:
    `methodName` -
    `methodArgs` -
    `symbolName` -
  Returns:
    a symbol or null if not handling